Token Pool Search
The Token Pool Search endpoint finds all liquidity pools containing a specific Solana token and returns trading statistics for each pool, including 24-hour volume, trade counts, and buy/sell breakdowns. It helps identify the most active trading venues for a given token across Solana DEXs.
GET
https://api.cambrian.org/solana/token-pool-search
Parameters
token_address* (string)
Token contract address (base58 format) to search pools for
limit (integer)
Limit the number of results.
offset (integer)
Offset the results, allows you to skip a number of rows before starting to return rows.
Responses
Code
Description
200
Successful response
Media type: application/vnd.cambrian.table.v1.0.0+json
[
{
"columns": [
{
"name": "tokenAddress",
"type": "String"
},
{
"name": "tokenSymbol",
"type": "String"
},
{
"name": "tokenName",
"type": "String"
},
{
"name": "tokenDecimals",
"type": "UInt8"
},
{
"name": "tokenPrice",
"type": "Float64"
},
{
"name": "poolAddress",
"type": "FixedString(44)"
},
{
"name": "poolDex",
"type": "String"
},
{
"name": "poolPairToken",
"type": "String"
},
{
"name": "volume24hUSD",
"type": "Float64"
},
{
"name": "volume24hToken",
"type": "Float64"
},
{
"name": "trades24hCount",
"type": "UInt64"
},
{
"name": "buys24hCount",
"type": "UInt64"
},
{
"name": "sells24hCount",
"type": "UInt64"
}
],
"data": [
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"YQwP3x59QT7HqA5TtjCmFhat5mxFBuUADnoXMUg9js8",
"pump_amm",
"NVDA",
141883505.81124693,
1920889.5645437944,
297245,
211300,
85945
],
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"6L3RTvmp1fZ3HVmQDHziF7WfRc2P1vCqy6biVPHDbffB",
"pump_amm",
"INTC",
140638424.35520402,
1904033.0316984504,
243623,
144463,
99160
],
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"CqPPZvtJJB7snvg5jURHVa2zYawT5Vd5MgZrBreyt7jM",
"pump_amm",
"NVDIA",
107801096.57037222,
1459464.9340275275,
161258,
91473,
69785
],
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"4gJbD9my9KErCd6F6hMfQbHgKR4SCJxUWC7sC7EEbULM",
"pump_amm",
"Monkey",
104502931.91113743,
1414812.7382712464,
108445,
54218,
54227
],
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"D7kjFM8eyernyL9YNkJujJKjM2GeMJuxxDbdVLQpg7iy",
"pump_amm",
"NVDA",
80218524.26880476,
1086038.333138196,
165115,
117456,
47659
],
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"7HdXDSP8iYoN6nYU3rAMu6pcQaZYP6mDrQrkXx3yRuXQ",
"pump_amm",
"Anthropic",
79366527.61225885,
1074503.578078207,
127633,
76591,
51042
],
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"Bkm5aYu8HQouqme6X4GrwuRYXpTWXb8mBQzfhzgunnKj",
"pump_amm",
"AIW3",
78102066.091259,
1057384.6682615366,
102963,
53722,
49241
],
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"EoF1WjKcfwfJ4jFEs8DkuYf5ptwH79djxy93je7yAi86",
"pump_amm",
"HOOD",
77281758.14204863,
1046278.9307035237,
121280,
71133,
50147
],
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"5gCQurcLXbhf6eV4uGXWjWawoxFysHx3zccQbBvxWDhW",
"pump_amm",
"HOOD",
69079234.27246518,
935229.077417792,
180565,
131313,
49252
],
[
"So11111111111111111111111111111111111111112",
"SOL",
"Wrapped SOL",
9,
73.86343724811887,
"FtBED1WfuP8V4HUHCefbsMF7cDFErFXbUGJZ4JRGzwGx",
"pump_amm",
"CATE",
63121689.277874194,
854572.8662184856,
82399,
44332,
38067
]
],
"rows": 10
}
]
400
Bad Request: Invalid request parameters or malformed request.
401
Unauthorized: Missing or invalid API key. Include X-API-Key header with your request.
403
Forbidden: Invalid API key or insufficient permissions to access this resource.
404
Not Found: Endpoint or resource does not exist.
408
Request Timeout: Request took too long to process. Try again.
500
Internal Server Error: An unexpected error occurred while processing your request.
503
Service Unavailable: The server is temporarily unable to handle the request. Please try again later.
Examples
1. Find Top Pools for Wrapped SOL
This example searches for pools containing Wrapped SOL and limits the results to the top 10, the most active trading venues for the token.
curl
curl -X GET "https://api.cambrian.org/solana/token-pool-search?token_address=So11111111111111111111111111111111111111112&limit=10" \
-H "X-API-Key: YOUR_API_KEY" \
-H "Content-Type: application/json"
Response:
JSON
1[
2 {
3 "columns": [
4 {
5 "name": "tokenAddress",
6 "type": "String"
7 },
8 {
9 "name": "tokenSymbol",
10 "type": "String"
11 },
12 {
13 "name": "tokenName",
14 "type": "String"
15 },
16 {
17 "name": "tokenDecimals",
18 "type": "UInt8"
19 },
20 {
21 "name": "tokenPrice",
22 "type": "Float64"
23 },
24 {
25 "name": "poolAddress",
26 "type": "FixedString(44)"
27 },
28 {
29 "name": "poolDex",
30 "type": "String"
31 },
32 {
33 "name": "poolPairToken",
34 "type": "String"
35 },
36 {
37 "name": "volume24hUSD",
38 "type": "Float64"
39 },
40 {
41 "name": "volume24hToken",
42 "type": "Float64"
43 },
44 {
45 "name": "trades24hCount",
46 "type": "UInt64"
47 },
48 {
49 "name": "buys24hCount",
50 "type": "UInt64"
51 },
52 {
53 "name": "sells24hCount",
54 "type": "UInt64"
55 }
56 ],
57 "data": [
58 [
59 "So11111111111111111111111111111111111111112",
60 "SOL",
61 "Wrapped SOL",
62 9,
63 73.86343724811887,
64 "YQwP3x59QT7HqA5TtjCmFhat5mxFBuUADnoXMUg9js8",
65 "pump_amm",
66 "NVDA",
67 141883505.81124693,
68 1920889.5645437944,
69 297245,
70 211300,
71 85945
72 ],
73 [
74 "So11111111111111111111111111111111111111112",
75 "SOL",
76 "Wrapped SOL",
77 9,
78 73.86343724811887,
79 "6L3RTvmp1fZ3HVmQDHziF7WfRc2P1vCqy6biVPHDbffB",
80 "pump_amm",
81 "INTC",
82 140638424.35520402,
83 1904033.0316984504,
84 243623,
85 144463,
86 99160
87 ],
88 [
89 "So11111111111111111111111111111111111111112",
90 "SOL",
91 "Wrapped SOL",
92 9,
93 73.86343724811887,
94 "CqPPZvtJJB7snvg5jURHVa2zYawT5Vd5MgZrBreyt7jM",
95 "pump_amm",
96 "NVDIA",
97 107801096.57037222,
98 1459464.9340275275,
99 161258,
100 91473,
101 69785
102 ],
103 [
104 "So11111111111111111111111111111111111111112",
105 "SOL",
106 "Wrapped SOL",
107 9,
108 73.86343724811887,
109 "4gJbD9my9KErCd6F6hMfQbHgKR4SCJxUWC7sC7EEbULM",
110 "pump_amm",
111 "Monkey",
112 104502931.91113743,
113 1414812.7382712464,
114 108445,
115 54218,
116 54227
117 ],
118 [
119 "So11111111111111111111111111111111111111112",
120 "SOL",
121 "Wrapped SOL",
122 9,
123 73.86343724811887,
124 "D7kjFM8eyernyL9YNkJujJKjM2GeMJuxxDbdVLQpg7iy",
125 "pump_amm",
126 "NVDA",
127 80218524.26880476,
128 1086038.333138196,
129 165115,
130 117456,
131 47659
132 ],
133 [
134 "So11111111111111111111111111111111111111112",
135 "SOL",
136 "Wrapped SOL",
137 9,
138 73.86343724811887,
139 "7HdXDSP8iYoN6nYU3rAMu6pcQaZYP6mDrQrkXx3yRuXQ",
140 "pump_amm",
141 "Anthropic",
142 79366527.61225885,
143 1074503.578078207,
144 127633,
145 76591,
146 51042
147 ],
148 [
149 "So11111111111111111111111111111111111111112",
150 "SOL",
151 "Wrapped SOL",
152 9,
153 73.86343724811887,
154 "Bkm5aYu8HQouqme6X4GrwuRYXpTWXb8mBQzfhzgunnKj",
155 "pump_amm",
156 "AIW3",
157 78102066.091259,
158 1057384.6682615366,
159 102963,
160 53722,
161 49241
162 ],
163 [
164 "So11111111111111111111111111111111111111112",
165 "SOL",
166 "Wrapped SOL",
167 9,
168 73.86343724811887,
169 "EoF1WjKcfwfJ4jFEs8DkuYf5ptwH79djxy93je7yAi86",
170 "pump_amm",
171 "HOOD",
172 77281758.14204863,
173 1046278.9307035237,
174 121280,
175 71133,
176 50147
177 ],
178 [
179 "So11111111111111111111111111111111111111112",
180 "SOL",
181 "Wrapped SOL",
182 9,
183 73.86343724811887,
184 "5gCQurcLXbhf6eV4uGXWjWawoxFysHx3zccQbBvxWDhW",
185 "pump_amm",
186 "HOOD",
187 69079234.27246518,
188 935229.077417792,
189 180565,
190 131313,
191 49252
192 ],
193 [
194 "So11111111111111111111111111111111111111112",
195 "SOL",
196 "Wrapped SOL",
197 9,
198 73.86343724811887,
199 "FtBED1WfuP8V4HUHCefbsMF7cDFErFXbUGJZ4JRGzwGx",
200 "pump_amm",
201 "CATE",
202 63121689.277874194,
203 854572.8662184856,
204 82399,
205 44332,
206 38067
207 ]
208 ],
209 "rows": 10
210 }
211]
2 {
3 "columns": [
4 {
5 "name": "tokenAddress",
6 "type": "String"
7 },
8 {
9 "name": "tokenSymbol",
10 "type": "String"
11 },
12 {
13 "name": "tokenName",
14 "type": "String"
15 },
16 {
17 "name": "tokenDecimals",
18 "type": "UInt8"
19 },
20 {
21 "name": "tokenPrice",
22 "type": "Float64"
23 },
24 {
25 "name": "poolAddress",
26 "type": "FixedString(44)"
27 },
28 {
29 "name": "poolDex",
30 "type": "String"
31 },
32 {
33 "name": "poolPairToken",
34 "type": "String"
35 },
36 {
37 "name": "volume24hUSD",
38 "type": "Float64"
39 },
40 {
41 "name": "volume24hToken",
42 "type": "Float64"
43 },
44 {
45 "name": "trades24hCount",
46 "type": "UInt64"
47 },
48 {
49 "name": "buys24hCount",
50 "type": "UInt64"
51 },
52 {
53 "name": "sells24hCount",
54 "type": "UInt64"
55 }
56 ],
57 "data": [
58 [
59 "So11111111111111111111111111111111111111112",
60 "SOL",
61 "Wrapped SOL",
62 9,
63 73.86343724811887,
64 "YQwP3x59QT7HqA5TtjCmFhat5mxFBuUADnoXMUg9js8",
65 "pump_amm",
66 "NVDA",
67 141883505.81124693,
68 1920889.5645437944,
69 297245,
70 211300,
71 85945
72 ],
73 [
74 "So11111111111111111111111111111111111111112",
75 "SOL",
76 "Wrapped SOL",
77 9,
78 73.86343724811887,
79 "6L3RTvmp1fZ3HVmQDHziF7WfRc2P1vCqy6biVPHDbffB",
80 "pump_amm",
81 "INTC",
82 140638424.35520402,
83 1904033.0316984504,
84 243623,
85 144463,
86 99160
87 ],
88 [
89 "So11111111111111111111111111111111111111112",
90 "SOL",
91 "Wrapped SOL",
92 9,
93 73.86343724811887,
94 "CqPPZvtJJB7snvg5jURHVa2zYawT5Vd5MgZrBreyt7jM",
95 "pump_amm",
96 "NVDIA",
97 107801096.57037222,
98 1459464.9340275275,
99 161258,
100 91473,
101 69785
102 ],
103 [
104 "So11111111111111111111111111111111111111112",
105 "SOL",
106 "Wrapped SOL",
107 9,
108 73.86343724811887,
109 "4gJbD9my9KErCd6F6hMfQbHgKR4SCJxUWC7sC7EEbULM",
110 "pump_amm",
111 "Monkey",
112 104502931.91113743,
113 1414812.7382712464,
114 108445,
115 54218,
116 54227
117 ],
118 [
119 "So11111111111111111111111111111111111111112",
120 "SOL",
121 "Wrapped SOL",
122 9,
123 73.86343724811887,
124 "D7kjFM8eyernyL9YNkJujJKjM2GeMJuxxDbdVLQpg7iy",
125 "pump_amm",
126 "NVDA",
127 80218524.26880476,
128 1086038.333138196,
129 165115,
130 117456,
131 47659
132 ],
133 [
134 "So11111111111111111111111111111111111111112",
135 "SOL",
136 "Wrapped SOL",
137 9,
138 73.86343724811887,
139 "7HdXDSP8iYoN6nYU3rAMu6pcQaZYP6mDrQrkXx3yRuXQ",
140 "pump_amm",
141 "Anthropic",
142 79366527.61225885,
143 1074503.578078207,
144 127633,
145 76591,
146 51042
147 ],
148 [
149 "So11111111111111111111111111111111111111112",
150 "SOL",
151 "Wrapped SOL",
152 9,
153 73.86343724811887,
154 "Bkm5aYu8HQouqme6X4GrwuRYXpTWXb8mBQzfhzgunnKj",
155 "pump_amm",
156 "AIW3",
157 78102066.091259,
158 1057384.6682615366,
159 102963,
160 53722,
161 49241
162 ],
163 [
164 "So11111111111111111111111111111111111111112",
165 "SOL",
166 "Wrapped SOL",
167 9,
168 73.86343724811887,
169 "EoF1WjKcfwfJ4jFEs8DkuYf5ptwH79djxy93je7yAi86",
170 "pump_amm",
171 "HOOD",
172 77281758.14204863,
173 1046278.9307035237,
174 121280,
175 71133,
176 50147
177 ],
178 [
179 "So11111111111111111111111111111111111111112",
180 "SOL",
181 "Wrapped SOL",
182 9,
183 73.86343724811887,
184 "5gCQurcLXbhf6eV4uGXWjWawoxFysHx3zccQbBvxWDhW",
185 "pump_amm",
186 "HOOD",
187 69079234.27246518,
188 935229.077417792,
189 180565,
190 131313,
191 49252
192 ],
193 [
194 "So11111111111111111111111111111111111111112",
195 "SOL",
196 "Wrapped SOL",
197 9,
198 73.86343724811887,
199 "FtBED1WfuP8V4HUHCefbsMF7cDFErFXbUGJZ4JRGzwGx",
200 "pump_amm",
201 "CATE",
202 63121689.277874194,
203 854572.8662184856,
204 82399,
205 44332,
206 38067
207 ]
208 ],
209 "rows": 10
210 }
211]
x402 Payment Option
This endpoint supports pay-per-use access via the x402 payment protocol (v2): pay $0.05 USDC per request using blockchain micropayments. No API key required.
Quickstart (Typescript)
bash
npm install @x402/fetch @x402/evm viem
TypeScript
1import { x402Client } from "@x402/core/client";
2import { ExactEvmScheme } from "@x402/evm/exact/client";
3import { wrapFetchWithPayment } from "@x402/fetch";
4import { privateKeyToAccount } from "viem/accounts";
5const signer = privateKeyToAccount(process.env.EVM_PRIVATE_KEY as `0x${string}`);
6const client = new x402Client();
7client.register("eip155:*", new ExactEvmScheme(signer));
8const fetchWithPayment = wrapFetchWithPayment(fetch, client);
9const response = await fetchWithPayment(
10 "https://x402.cambrian.org/solana/token-pool-search"
11);
12const data = await response.json();
2import { ExactEvmScheme } from "@x402/evm/exact/client";
3import { wrapFetchWithPayment } from "@x402/fetch";
4import { privateKeyToAccount } from "viem/accounts";
5const signer = privateKeyToAccount(process.env.EVM_PRIVATE_KEY as `0x${string}`);
6const client = new x402Client();
7client.register("eip155:*", new ExactEvmScheme(signer));
8const fetchWithPayment = wrapFetchWithPayment(fetch, client);
9const response = await fetchWithPayment(
10 "https://x402.cambrian.org/solana/token-pool-search"
11);
12const data = await response.json();
Quickstart (Python)
bash
pip install "x402[httpx]"
Python
1import asyncio, os
2from eth_account import Account
3from x402 import x402Client
4from x402.http.clients import x402HttpxClient
5from x402.mechanisms.evm import EthAccountSigner
6from x402.mechanisms.evm.exact.register import register_exact_evm_client
7async def main():
8 client = x402Client()
9 account = Account.from_key(os.getenv("EVM_PRIVATE_KEY"))
10 register_exact_evm_client(client, EthAccountSigner(account))
11 async with x402HttpxClient(client) as http:
12 response = await http.get("https://x402.cambrian.org/solana/token-pool-search")
13 print(response.json())
14asyncio.run(main())
2from eth_account import Account
3from x402 import x402Client
4from x402.http.clients import x402HttpxClient
5from x402.mechanisms.evm import EthAccountSigner
6from x402.mechanisms.evm.exact.register import register_exact_evm_client
7async def main():
8 client = x402Client()
9 account = Account.from_key(os.getenv("EVM_PRIVATE_KEY"))
10 register_exact_evm_client(client, EthAccountSigner(account))
11 async with x402HttpxClient(client) as http:
12 response = await http.get("https://x402.cambrian.org/solana/token-pool-search")
13 print(response.json())
14asyncio.run(main())
Payment Flow
- Send a normal request to the endpoint (no API key needed)
- Server returns 402 Payment Required with payment details
- The x402 SDK automatically signs a payment authorization with your wallet
- The SDK resubmits the request with the signed payment
- Server verifies payment and returns the API response
The x402 SDK handles steps 2 through 5 automatically.
Network: Base (chain ID 8453) | Currency: USDC | Price: $0.05 per request